<?php

$show_all = true;
only_unreg();

if (isset($_POST['recovery'])) {
    $email = use_filters('ds_esc_input', $_POST['email']); 

    if (!validate_email($email)) {
        add_error(__('Проверьте правильность E-Mail адреса')); 
    }
    
    if (!is_errors()) {
        $tmp_user = db::fetch("SELECT `id` FROM `user` WHERE `email` = '" . $email . "' LIMIT 1", ARRAY_A); 

        if (!isset($tmp_user['id'])) {
            add_error(__('Пользователь с указанным E-Mail не найден')); 
        }
    }

    if (!is_errors()) {
        $code = mt_rand(1000, 9999); 
        update_user_meta($tmp_user['id'], '__recovery_code', $code); 

        $tmp_user = get_user($tmp_user['id']);

        $content = __('Восстановление пароля на сайте %s', $_SERVER['HTTP_HOST']) . "\n\n"; 
        $content .= __('Для завершения процедуры, перейдите по этой ссылке: %s', get_query_url(array(
            'id' => $tmp_user['id'], 
            'hash' => md5($code . ':' . SALT_FORMS_FIELDS), 
        ))); 

        $mail_title = use_filters('ds_recovery_code_title', __('Восстановление доступа на %s', $_SERVER['HTTP_HOST'])); 
        $mail_message = use_filters('ds_recovery_code_message', $content); 
        $mail_headers = use_filters('ds_recovery_code_headers', array()); 
        $mail_attachments = use_filters('ds_recovery_code_attachments', array());  

        ds_mail($tmp_user['email'], $mail_title, $mail_message, $mail_headers, $mail_attachments);

        $_SESSION['message'] = __('На ваш E-Mail отправлено сообщение с ссылкой для восстановления пароля'); 

        do_event('user_recovery_success', $tmp_user); 
        ds_redirect('?sid=' . passgen(10)); 
    }
}

if (isset($_GET['hash'])) {
    $user_id = (int) $_GET['id']; 

    $code = get_user_meta($_GET['id'], '__recovery_code'); 
    $hash = md5($code . ':' . SALT_FORMS_FIELDS); 

    if ($hash !== $_GET['hash']) {
        add_error(__('Эта ссылка больше не действительна')); 
    }

    if (!is_errors()) {
        $tmp_user = get_user($user_id); 
        $password = passgen(6); 

        $content = __('Поздравляем! Теперь вы снова можете авторизоваться на сайте %s', $_SERVER['HTTP_HOST']) . "\n\n"; 
        $content .= __('Новый пароль для входа в аккаунт: %s', $password) . "\n"; 
        $content .= __('Ссылка для авторизации на сайте: %s', get_site_url('/aut.php')); 

        $mail_title = use_filters('ds_recovery_pass_title', __('Доступ восстановлен')); 
        $mail_message = use_filters('ds_recovery_pass_message', $content); 
        $mail_headers = use_filters('ds_recovery_pass_headers', array()); 
        $mail_attachments = use_filters('ds_recovery_pass_attachments', array());  

        ds_mail($tmp_user['email'], $mail_title, $mail_message, $mail_headers, $mail_attachments);

        delete_user_meta($user_id, '__recovery_code');

        db::update('user', array(
            'pass' => shif($password), 
        ), array(
            'id' => $user_id,
        )); 

        $_SESSION['message'] = __('Доступ успешно восстановлен, новый пароль отправлен на ваш E-Mail'); 
        ds_redirect('/aut.php'); 
    }
}

$set['title'] = __('Восстановить пароль');

get_header(); 
?>
<form class="ds-auth-form" action="?" method="POST">
    <?php do_event('ds_recovery_fields_before'); ?>

    <div class="ds-auth-input ds-auth-input-email">
        <label for="email"><?php echo __('E-Mail адрес'); ?></label>
        <input id="email" type="text" name="email" />
    </div>

    <?php do_event('ds_recovery_fields_after'); ?>

    <div class="ds-auth-submit">
        <button class="button" type="submit"><?php echo __('Продолжить'); ?></button>
    </div>

    <?php do_event('ds_recovery_form_end'); ?>

    <input type="hidden" name="recovery" value="1" />
</form>
<?

get_footer();  